<!-- 订单列表  order-->
<template >
  <div ref="main_box">
    <van-sticky :offset-top="oTop">
    <van-tabs title-inactive-color="#444" v-model="search.status" :title-active-color="m_color" :color="m_color" class="zwTab" @change="change">
      <van-tab v-for="(item ,index ) in List" :key="index" :title="item.name" :name="item.id">
      </van-tab>
    </van-tabs>
    </van-sticky>
    <div class="m_main_box">
      <van-list :immediate-check="false" v-model="list_loading" :finished="list_finished" @load="m_loadList">
        <div @click="routerPush(item)" class="order-item" v-for="(item , i ) in m_data" :key="i">
          <div class="flex flex-m bor-b">
            <div class="flex-1 order-lable">订单号：{{item.order_no}}</div>
            <div class="o_status" :class="item.status | orderStatusClass">{{item.status | BaseData('orders','status')}}</div>
            <van-icon name="arrow" color="#999" />
          </div>

          <van-card :lazy-load="true" class="bgfff" v-for="(order_goods,order_goods_index) in item.order_goods" :key="order_goods_index" :num="order_goods.num" :price="order_goods.price" :title="order_goods.title" :thumb="order_goods.images | img">
            <div slot="bottom">
              <div v-if="order_goods.option_title">{{order_goods.option_title | replaceStr}}</div>
            </div>
            <div slot="footer">
              <!-- <span class="m_color">{{order_goods.num}}</span> {{order_goods.unit | unit}}商品，小计<span class="m_color"> ¥ {{order_goods.total}}</span> -->
            </div>
          </van-card>
          <div class="order-footer tr ">
            <div>共 <span class="ml5 mr5">{{item.total_num }} </span>个商品 总计: ¥<span class="m_pricr ml5">{{item.total_amount | toNum(2)}}</span></div>
            <div class="pt15 pb5 flex flex-m flex-r">
              <div v-if="item.status==0" class="flex flex-m">
                <div @click.stop="regenerate_copy_url(item,i )" class="btn-o-b mr10">生成代付连接</div>
                <div @click.stop="order_close(item,i )" class="btn-o-b mr10">取消订单</div>
                <div @click.stop="goPay(item )" class="btn-o">支付订单</div>
              </div>
              <div v-if="item.status==2">
                <div @click.stop="order_confirm(item,i )" class="btn-o">确认收货</div>
              </div>
            </div>
          </div>

        </div>
      </van-list>
    </div>
    <nodata v-if="!m_hasData&&!list_loading" />
  </div>
</template>

<script>
import mixin from './mixin/index'
export default {
  name: 'order',
  mixins: [mixin],
  data() {
    return {
      m_pageInfo: {
        limit: 10,
        page: 1,
      },
      search: {
        status: '',
      },
      list: [],
      active: '',
    }
  },
  computed: {
    List() {
      let item = {
        name: '全部',
        id: ''
      }
      return [...[item, ...this.list]]
    }
  },

  beforeRouteEnter(to, from, next) {
    let path = from.path
    let keeps = ['/orderDetial', '/goodsPay']
    if (keeps.includes(path)) {
      to.meta.keepAlive = 1
    } else {
      to.meta.keepAlive = 0
    }

    next()
  },



  activated() {
    let keepAlive = this.$route.meta.keepAlive
    if (sessionStorage.order_status) {
      this.init()
      return
    }
    if (keepAlive == 1) {
      this.handeKeepAlive()
    } else {
      this.init()
    }
  },

  created() {

  },

  methods: {
    init() {
      this.m_resetData()
      let query = this.$route.query

      this.search.status = sessionStorage.order_status || query.status || ''

      sessionStorage.order_status = ''
      this.m_loadList()

      this.getListData()

    },

    getListData() {
      this.list = this.GetBaseData('orders', 'status')
    },

    handeKeepAlive() {
      let _scrollTop = this.isNaN0(sessionStorage.scrollTop)
      sessionStorage.scrollTop = ''
      this.$refs.main_box.scrollTop = _scrollTop

    },

    getDataList() {
      let data = { ...this.m_pageInfo, ...this.search }
      return this.api.orders(data).then(res => {
        this.m_data = [...this.m_data, ...res.data.data]
        return res

      })
    },

    //确认收货
    order_confirm(item, index) {
      this.$dialog.confirm({
        title: '提示',
        message: '是否确认收货？'
      }).then(() => {
        this.m_loading()
        this.api.order_confirm({ id: item.id }).then(res => {
          this.m_hideLoading()
          this.m_success('操作成功')
          this.m_data.splice(index, 1)
          // this.search.status = '3'
          // this.change()


        })
      }).catch(() => {
        // on cancel
      });

    },

    //切换tab
    change() {
      this.$nextTick(() => {
        this.search.status = this.search.status === 0 ? '' : this.search.status
        this.clearScrollResult()
        this.m_loadList()
      })
    },

    order_close_cb(row, index) {

      this.m_data.splice(index, 1)

    },

    routerPush(item) {
      sessionStorage.scrollTop = this.$refs.main_box.scrollTop
      this.$router.push(`/orderDetial?id=${item.id}`)
    },
    regenerate_copy_url(data,index)
    {
      this.m_loading();
      let form = {
        order_id:data.id,
        order_no:data.order_no,
        amount:data.goods_amount,
        pay_type: 'alipay-later',
        pay_password: '',
        type:data.type
      };

      return this.api.pay_order(form).then(res => {
        this.show = false;
        this.m_hideLoading();
        this.m_success('代付链接已复制，请发给对象付款。');
        this.$copyText(res.data).then(function (e) {
          console.log(e)
        }, function (e) {
          alert('Can not copy')
          console.log(e)
        })
      })
    },
  }

}

</script>
<style lang='scss' scoped>
.m_main_box {
  height: 100%;
  padding-right: 0.26rem ;
  padding-left: 0.26rem;
  box-sizing: border-box;

}

.orders {
  padding-top: 0.9rem;
}
.order-item {
  padding: 0.26rem;
  padding-bottom: 0.1rem;
  background: #fff;
  margin-bottom: 0.15rem;
  margin-top: 0.15rem;
  color: #333;
  font-size: 0.28rem;
  border-radius: 0.14rem;
}

.order-lable {
  color: #747474;
  font-size: 0.26rem;
}

.o_status{
  font-size: 0.28rem;
  font-weight: bold;
}


.bor-b {
  padding-bottom: 0.26rem;
  border-bottom: 1px solid #eee;
}
.bor-t {
  padding-bottom: 0.26rem;
  border-top: 1px solid #eee;
}

.order-footer {
  padding-right: 0.3rem;
  font-size: 0.26rem;

 
  // border-top: 1px solid #eee;
  color: #333;
}




</style>

<style lang='scss' >

.zwTab{
  .van-tabs__nav{
    background: #F8F8F8;
  }
}
</style>